require("scripts.Player")
require("scripts.Floor")
require("scripts.extra")
require("scripts.Menu")
require("Platforms.Platform_1")
require("Platforms.Platform_2")
require("Platforms.Platform_3")
require("Platforms.Platform_Loader")

function love.load()
    TheBackground = love.graphics.newImage("assets/Background/Background_1.png")
    Menu:load()
    PlatformImage_1 = love.graphics.newImage("assets/Platforms/Platform_1.png")
    debugging = false
    Level = 1
    love.window.setTitle("My Platformer Game")
    love.window.setMode(800, 600, {resizable = false})
    Window_Width = love.graphics.getWidth()
    Window_Height = love.graphics.getHeight()
    Width_Half = Window_Width / 2
    Height_Half = Window_Height / 2
    gravity = 500
    Player:load()
    Floor:load()
    PlatformsLoad()
end

function love.update(dt)
    if Menu.on then
        Menu.update(dt)
    else
        updatewhennotmenu(dt)
    end
end

function updatewhennotmenu(dt)
    Platformsupdate(dt)
    update_Platforms()
    Player:update(dt)
    if Level == 1 then
        Floor:update(dt)
    end
    if love.keyboard.isDown("f1") then
        debugging = not debugging
    end
    Platformsupdate(dt)
    update_Platforms()
end

function love.draw()
    love.graphics.draw(TheBackground, 0, 0)
    if Menu.on then
        Menu.draw()
    else
        drawwhennotmenu()
    end
end

function drawwhennotmenu()
    Player:draw()
    if Level == 1 then
        Floor:draw()
    end
    Platformsdraw()
end

function checkCollision(x1, y1, width1, height1, x2, y2, width2, height2)
    if x1 + width1 > x2 and x1 < x2 + width2 and y1 + height1 > y2 and y1 < y2 + height2 then
        return true
    else
        return false
    end
end

function PlatformsLoad()
    Platform_1:load()
    Platform_2:load()
    Platform_3:load()
end

function Platformsupdate(dt)
    Platform_1:update(dt)
    Platform_2:update(dt)
    Platform_3:update(dt)
end

function Platformsdraw()
    Platform_1:draw()
    Platform_2:draw()
    Platform_3:draw()
end

function times64(amountx)
    return 64 * amountx
end

function NextLevel()
    Level = Level + 1
    update_Platforms()
    Player.ypos = Window_Height - Player.Height
end

function PreviousLevel()
    Level = Level - 1
    update_Platforms()
    Player.ypos = 0
end

function love.keypressed(key)
    if key == "escape" then
        Menu.on = true
        Menu.Option = 1
    end
    if key == "up" or key == "w" then
        if Menu.on then
            if Menu.Option == 1 then
                Menu.Option = 1
            end
            if Menu.Option == 2 then
                Menu.Option = 1
            end
            if Menu.Option == 3 then
                Menu.Option = 2
            end
        end
    end
    if key == "down" or key == "s" then
        if Menu.on then
            if Menu.Option == 2 then
                Menu.Option = 3
            end
            if Menu.Option == 3 then
                Menu.Option = 3
            end
            if Menu.Option == 1 then
                Menu.Option = 2
            end
        end
    end
    if key == "right" or key == "d" then
        if Menu.on and Menu.Settings then
            if Menu.Settings_Option == 1 then
                if love.window.getFullscreen() == false then
                    love.window.setFullscreen(true)
                elseif love.window.getFullscreen() then
                    love.window.setFullscreen(false)
                end
            end
        end
    end
end